e number of tries that should be performed before failing the
      task.
    name: Required. The resource name of the task instance, in the form: "proj
      ects/{project_id}/locations/{location_id}/environments/{environment_id}/
      dags/{dag_id}/dagRuns/{dag_run_id}/taskInstances/{task_instance_id_with_
      optional_map_index}".
    pool: The slot pool this task runs in.
    priorityWeight: Priority weight of this task against other tasks.
    queue: Which queue to target when running this task.
    queuedDttm: Timestamp when the task was queued.
    renderedMapIndex: Named mapping - a rendered map index template for this
      task instance. If task doesn't have a template specified or
      is_dynamically_mapped is set to false, this field is empty.
    startDate: Timestamp when the task instance started execution.
    state: Task instance state.
    taskId: The task instance ID. It is the same as the task ID in the DAG.
    taskType: The operator used in this task.
    tryNumber: The try number that this task number will be when it is
      actually run.
  """

  class StateValueValuesEnum(_messages.Enum):
    r"""Task instance state.

    Values:
      STATE_UNSPECIFIED: The state of the task instance is unknown.
      SUCCEEDED: Task execution succeeded.
      FAILED: Task execution failed.
      UPSTREAM_FAILED: Upstream task failed.
      SKIPPED: Task skipped.
      UP_FOR_RETRY: Task waiting to be retried.
      UP_FOR_RESCHEDULE: Task waiting to be rescheduled.
      QUEUED: Task queued.
      SCHEDULED: Task scheduled for execution.
      SENSING: Task in sensing mode.
      REMOVED: Task vanished from DAG before it ran.
      RUNNING: Task is executing.
      SHUTDOWN: External request to shut down (e.g. marked failed when
        running).
      RESTARTING: External request to restart (e.g. cleared when running).
      DEFERRED: Deferrable operator waiting on a trigger.
    """
    STATE_UNSPECIFIED = 0
    SUCCEEDED = 1
    FAILED = 2
    UPSTREAM_FAILED = 3
    SKIPPED = 4
    UP_FOR_RETRY = 5
    UP_FOR_RESCHEDULE = 6
    QUEUED = 7
    SCHEDULED = 8
    SENSING = 9
    REMOVED = 10
    RUNNING = 11
    SHUTDOWN = 12
    RESTARTING = 13
    DEFERRED = 14

  dagId = _messages.StringField(1)
  dagRunId = _messages.StringField(2)
  endDate = _messages.StringField(3)
  executionDate = _messages.StringField(4)
  externalExecutorId = _messages.StringField(5)
  hostname = _messages.StringField(6)
  id = _messages.StringField(7)
  isDynamicallyMapped = _messages.BooleanField(8)
  mapIndex = _messages.IntegerField(9, variant=_messages.Variant.INT32)
  maxTries = _messages.IntegerField(10, variant=_messages.Variant.INT32)
  name = _messages.StringField(11)
  pool = _messages.StringField(12)
  priorityWeight = _messages.IntegerField(13, variant=_messages.Variant.INT32)
  queue = _messages.StringField(14)
  queuedDttm = _messages.StringField(15)
  renderedMapIndex = _messages.StringField(16)
  startDate = _messages.StringField(17)
  state = _messages.EnumField('StateValueValuesEnum', 18)
  taskId = _messages.StringField(19)
  taskType = _messages.StringField(20)
  tryNumber = _messages.IntegerField(21, variant=_messages.Variant.INT32)


class TaskLogsRetentionConfig(_messages.Message):
  r"""The configuration setting for Task Logs.

  Enums:
    StorageModeValueValuesEnum: Optional. The mode of storage for Airflow
      workers task logs.

  Fields:
    retentionDays: Optional. The number of days to retain task logs in the
      Cloud Logging bucket
    storageMode: Optional. The mode of storage for Airflow workers task logs.
  """

  class StorageModeValueValuesEnum(_messages.Enum):
    r"""Optional. The mode of storage for Airflow workers task logs.

    Values:
      TASK_LOGS_STORAGE_MODE_UNSPECIFIED: This configuration is not specified
        by the user.
      CLOUD_LOGGING_AND_CLOUD_STORAGE: Store task logs in Cloud Logging and in
        the environment's Cloud Storage bucket.
      CLOUD_LOGGING_ONLY: Store task logs in Cloud Logging only.
    """
    TASK_LOGS_STORAGE_MODE_UNSPECIFIED = 0
    CLOUD_LOGGING_AND_CLOUD_STORAGE = 1
    CLOUD_LOGGING_ONLY = 2

  retentionDays = _messages.IntegerField(1, variant=_messages.Variant.INT32)
  storageMode = _messages.EnumField('StorageModeValueValuesEnum', 2)


class TriggerDagRequest(_messages.Message):
  r"""Request to trigger a DAG run.

  Messages:
    ConfValue: The key-value pairs get pickled into the conf attribute in the
      DAG run.

  Fields:
    conf: The key-value pairs get pickled into the conf attribute in the DAG
      run.
    dagRunId: The dag_run_id to be assigned to the triggered DAG run.
    executionDate: The execution date of the DAG run.
  """

  @encoding.MapUnrecognizedFields('additionalProperties')
  class ConfValue(_messages.Message):
    r"""The key-value pairs get pickled into the conf attribute in the DAG
    run.

    Messages:
      AdditionalProperty: An additional property for a ConfValue object.

    Fields:
      additionalProperties: Properties of the object.
    """

    class AdditionalProperty(_messages.Message):
      r"""An additional property for a ConfValue object.

      Fields:
        key: Name of the additional property.
        value: A extra_types.JsonValue attribute.
      """

      key = _messages.StringField(1)
      value = _messages.MessageField('extra_types.JsonValue', 2)

    additionalProperties = _messages.MessageField('AdditionalProperty', 1, repeated=True)

  conf = _messages.MessageField('ConfValue', 1)
  dagRunId = _messages.StringField(2)
  executionDate = _messages.StringField(3)


class TriggererResource(_messages.Message):
  r"""Configuration for resources used by Airflow triggerers.

  Fields:
    count: Optional. The number of triggerers.
    cpu: Optional. CPU request and limit for a single Airflow triggerer
      replica.
    memoryGb: Optional. Memory (GB) request and limit for a single Airflow
      triggerer replica.
  """

  count = _messages.IntegerField(1, variant=_messages.Variant.INT32)
  cpu = _messages.FloatField(2, variant=_messages.Variant.FLOAT)
  memoryGb = _messages.FloatField(3, variant=_messages.Variant.FLOAT)


class UserWorkloadsConfigMap(_messages.Message):
  r"""User workloads ConfigMap used by Airflow tasks that run with Kubernetes
  executor or KubernetesPodOperator.

  Messages:
    DataValue: Optional. The "data" field of Kubernetes ConfigMap, organized
      in key-value pairs. For details see:
      https://kubernetes.io/docs/concepts/configuration/configmap/ Example: {
      "example_key": "example_value", "another_key": "another_value" }

  Fields:
    data: Optional. The "data" field of Kubernetes ConfigMap, organized in
      key-value pairs. For details see:
      https://kubernetes.io/docs/concepts/configuration/configmap/ Example: {
      "example_key": "example_value", "another_key": "another_value" }
    name: Identifier. The resource name of the ConfigMap, in the form: "projec
      ts/{projectId}/locations/{locationId}/environments/{environmentId}/userW
      orkloadsConfigMaps/{userWorkloadsConfigMapId}"
  """

  @encoding.MapUnrecognizedFields('additionalProperties')
  class DataValue(_messages.Message):
    r"""Optional. The "data" field of Kubernetes ConfigMap, organized in key-
    value pairs. For details see:
    https://kubernetes.io/docs/concepts/configuration/configmap/ Example: {
    "example_key": "example_value", "another_key": "another_value" }

    Messages:
      AdditionalProperty: An additional property for a DataValue object.

    Fields:
      additionalProperties: Additional properties of type DataValue
    """

    class AdditionalProperty(_messages.Message):
      r"""An additional property for a DataValue object.

      Fields:
        key: Name of the additional property.
        value: A string attribute.
      """

      key = _messages.StringField(1)
      value = _messages.StringField(2)

    additionalProperties = _messages.MessageField('AdditionalProperty', 1, repeated=True)

  data = _messages.MessageField('DataValue', 1)
  name = _messages.StringField(2)


class UserWorkloadsSecret(_messages.Message):
  r"""User workloads Secret used by Airflow tasks that run with Kubernetes
  executor or KubernetesPodOperator.

  Messages:
    DataValue: Optional. The "data" field of Kubernetes Secret, organized in
      key-value pairs, which can contain sensitive values such as a password,
      a token, or a key. The values for all keys have to be base64-encoded
      strings. For details see:
      https://kubernetes.io/docs/concepts/configuration/secret/ Example: {
      "example": "ZXhhbXBsZV92YWx1ZQ==", "another-example":
      "YW5vdGhlcl9leGFtcGxlX3ZhbHVl" }

  Fields:
    data: Optional. The "data" field of Kubernetes Secret, organized in key-
      value pairs, which can contain sensitive values such as a password, a
      token, or a key. The values for all keys have to be base64-encoded
      strings. For details see:
      https://kubernetes.io/docs/concepts/configuration/secret/ Example: {
      "example": "ZXhhbXBsZV92YWx1ZQ==", "another-example":
      "YW5vdGhlcl9leGFtcGxlX3ZhbHVl" }
    name: Identifier. The resource name of the Secret, in the form: "projects/
      {projectId}/locations/{locationId}/environments/{environmentId}/userWork
      loadsSecrets/{userWorkloadsSecretId}"
  """

  @encoding.MapUnrecognizedFields('additionalProperties')
  class DataValue(_messages.Message):
    r"""Optional. The "data" field of Kubernetes Secret, organized in key-
    value pairs, which can contain sensitive values such as a password, a
    token, or a key. The values for all keys have to be base64-encoded
    strings. For details see:
    https://kubernetes.io/docs/concepts/configuration/secret/ Example: {
    "example": "ZXhhbXBsZV92YWx1ZQ==", "another-example":
    "YW5vdGhlcl9leGFtcGxlX3ZhbHVl" }

    Messages:
      AdditionalProperty: An additional property for a DataValue object.

    Fields:
      additionalProperties: Additional properties of type DataValue
    """

    class AdditionalProperty(_messages.Message):
      r"""An additional property for a DataValue object.

      Fields:
        key: Name of the additional property.
        value: A string attribute.
      """

      key = _messages.StringField(1)
      value = _messages.StringField(2)

    additionalProperties = _messages.MessageField('AdditionalProperty', 1, repeated=True)

  data = _messages.MessageField('DataValue', 1)
  name = _messages.StringField(2)


class WebServerConfig(_messages.Message):
  r"""The configuration settings for the Airflow web server App Engine
  instance. Supported for Cloud Composer environments in versions
  composer-1.*.*-airflow-*.*.*.

  Fields:
    machineType: Optional. Machine type on which Airflow web server is
      running. It has to be one of: composer-n1-webserver-2,
      composer-n1-webserver-4 or composer-n1-webserver-8. If not specified,
      composer-n1-webserver-2 will be used. Value custom is returned only in
      response, if Airflow web server parameters were manually changed to a
      non-standard values.
  """

  machineType = _messages.StringField(1)


class WebServerNetworkAccessControl(_messages.Message):
  r"""Network-level access control policy for the Airflow web server.

  Fields:
    allowedIpRanges: A collection of allowed IP ranges with descriptions.
  """

  allowedIpRanges = _messages.MessageField('AllowedIpRange', 1, repeated=True)


class WebServerResource(_messages.Message):
  r"""Configuration for resources used by Airflow web server.

  Fields:
    count: Optional. The number of web server instances. If not provided or
      set to 0, a single web server instance will be created.
    cpu: Optional. CPU request and limit for Airflow web server.
    memoryGb: Optional. Memory (GB) request and limit for Airflow web server.
    storageGb: Optional. Storage (GB) request and limit for Airflow web
      server.
  """

  count = _messages.IntegerField(1, variant=_messages.Variant.INT32)
  cpu = _messages.FloatField(2, variant=_messages.Variant.FLOAT)
  memoryGb = _messages.FloatField(3, variant=_messages.Variant.FLOAT)
  storageGb = _messages.FloatField(4, variant=_messages.Variant.FLOAT)


class WorkerResource(_messages.Message):
  r"""Configuration for resources used by Airflow workers.

  Fields:
    cpu: Optional. CPU request and limit for a single Airflow worker replica.
    maxCount: Optional. Maximum number of workers for autoscaling.
    memoryGb: Optional. Memory (GB) request and limit for a single Airflow
      worker replica.
    minCount: Optional. Minimum number of workers for autoscaling.
    storageGb: Optional. Storage (GB) request and limit for a single Airflow
      worker replica.
  """

  cpu = _messages.FloatField(1, variant=_messages.Variant.FLOAT)
  maxCount = _messages.IntegerField(2, variant=_messages.Variant.INT32)
  memoryGb = _messages.FloatField(3, variant=_messages.Variant.FLOAT)
  minCount = _messages.IntegerField(4, variant=_messages.Variant.INT32)
  storageGb = _messages.FloatField(5, variant=_messages.Variant.FLOAT)


class WorkloadsConfig(_messages.Message):
  r"""The Kubernetes workloads configuration for GKE cluster associated with
  the Cloud Composer environment. Supported for Cloud Composer environments in
  versions composer-2.*.*-airflow-*.*.* and newer.

  Fields:
    dagProcessor: Optional. Resources used by Airflow DAG processors. This
      field is supported for Cloud Composer environments in versions
      composer-3-airflow-*.*.*-build.* and newer.
    scheduler: Optional. Resources used by Airflow scheduler.
    schedulerCpu: Optional. CPU request and limit for Airflow scheduler.
    triggerer: Optional. Resources used by Airflow triggerers.
    webServer: Optional. Resources used by Airflow web server.
    worker: Optional. Resources used by Airflow workers.
    workerCpu: Optional. CPU request and limit for Airflow worker.
    workerMaxCount: Optional. Maximum number of workers for autoscaling.
    workerMinCount: Optional. Minimum number of workers for autoscaling.
  """

  dagProcessor = _messages.MessageField('DagProcessorResource', 1)
  scheduler = _messages.MessageField('SchedulerResource', 2)
  schedulerCpu = _messages.FloatField(3, variant=_messages.Variant.FLOAT)
  triggerer = _messages.MessageField('TriggererResource', 4)
  webServer = _messages.MessageField('WebServerResource', 5)
  worker = _messages.MessageField('WorkerResource', 6)
  workerCpu = _messages.FloatField(7, variant=_messages.Variant.FLOAT)
  workerMaxCount = _messages.IntegerField(8, variant=_messages.Variant.INT32)
  workerMinCount = _messages.IntegerField(9, variant=_messages.Variant.INT32)


encoding.AddCustomJsonFieldMapping(
    StandardQueryParameters, 'f__xgafv', '$.xgafv')
encoding.AddCustomJsonEnumMapping(
    StandardQueryParameters.FXgafvValueValuesEnum, '_1', '1')
encoding.AddCustomJsonEnumMapping(
    StandardQueryParameters.FXgafvValueValuesEnum, '_2', '2')
encoding.AddCustomJsonFieldMapping(
    ComposerProjectsLocationsEnvironmentsDagsListStatsRequest, 'interval_endTime', 'interval.endTime')
encoding.AddCustomJsonFieldMapping(
    ComposerProjectsLocationsEnvironmentsDagsListStatsRequest, 'interval_startTime', 'interval.startTime')
